#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com" 

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Red
#property indicator_color2  RoyalBlue
#property indicator_color3  Red
#property indicator_color4  RoyalBlue
#property indicator_color5  Yellow
#property indicator_color6  Yellow
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  1
#property indicator_width6  1

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    Upper_Ma_Period    = 5;
extern int    Lower_Ma_Period    = 5;
extern string _not               = "Ma Types";
extern string _note              = "0=sma,1=ema,2=ssma,3=lwms";
extern int    Upper_Ma_Method    = 2;
extern int    Lower_Ma_Method    = 2;
extern string _note1             = "0=close,1=open,2=high,3=low";
extern string _cont              = "4=H+L/2,5=H+L+C/3,6=H+L+C+C/4";
extern int    Upper_Ma_Price     = PRICE_HIGH;
extern int    Lower_Ma_Price     = PRICE_LOW;
extern bool   HAOnFirst          = true;
extern bool   ShowChannels       = true;

extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;

extern bool   arrowsVisible      = true;
extern string arrowsIdentifier   = "PA Arrows1";
extern double arrowsDisplacement = 1.0;
extern color  arrowsUpColor      = LimeGreen;
extern color  arrowsDnColor      = Orange;
extern int    arrowsUpCode       = 241;
extern int    arrowsDownCode     = 242;



//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double uPac[];
double lPac[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//               



int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, uPac);        
   SetIndexBuffer(5, lPac);       
   SetIndexBuffer(6, trend);
   
   if (ShowChannels)
   {
     SetIndexStyle(4,DRAW_LINE); 
     SetIndexStyle(5,DRAW_LINE); 
   }
   else
   {
     SetIndexStyle(4,DRAW_NONE);
     SetIndexStyle(5,DRAW_NONE);
   }       
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" PA Bars and Channel");   
return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}
  
//
//
//
//
//
  
int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);  
          if (returnBars) { Buffer1[0] = limit+1; return(0); }   
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     for (pos=limit; pos >= 0; pos--)
     {                    
         double haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
         double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
         double haHigh  = MathMax(High[pos],MathMax(Open[pos],Close[pos]));
         double haLow   = MathMin(Low[pos], MathMin(Open[pos],Close[pos]));
          
         if (haOpen<haClose) { Buffer1[pos]= haLow;  Buffer2[pos]=haHigh; } 
         else                { Buffer1[pos]= haHigh; Buffer2[pos]=haLow;  } 
                               Buffer3[pos]= haOpen;
                               Buffer4[pos]= haClose;   
                               uPac[pos]   = iMA(NULL,0,Upper_Ma_Period,0,Upper_Ma_Method,Upper_Ma_Price,pos);  
                               lPac[pos]   = iMA(NULL,0,Lower_Ma_Period,0,Lower_Ma_Method,Lower_Ma_Price,pos);             
     
          trend[pos] = trend[pos+1];
          if (Buffer3[pos] > Buffer4[pos] && haLow  < lPac[pos]) trend[pos] = -1;
          if (Buffer3[pos] < Buffer4[pos] && haHigh > uPac[pos]) trend[pos] =  1;
          manageArrow(pos);
      }
      manageAlerts();
      return(0);
   }
          
   //
   //
   //
   //
   //
   
   int displace = -1; if (HAOnFirst) displace = 1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(pos = limit; pos >= 0; pos--)
   {
      int y = iBarShift(NULL,timeFrame,Time[pos]);
      int x = iBarShift(NULL,timeFrame,Time[pos+displace]);
         uPac[pos]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Upper_Ma_Period,Lower_Ma_Period,"","",Upper_Ma_Method,Lower_Ma_Method,"","",Upper_Ma_Price,Lower_Ma_Price,4,y);
         lPac[pos]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Upper_Ma_Period,Lower_Ma_Period,"","",Upper_Ma_Method,Lower_Ma_Method,"","",Upper_Ma_Price,Lower_Ma_Price,5,y);
         trend[pos]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Upper_Ma_Period,Lower_Ma_Period,"","",Upper_Ma_Method,Lower_Ma_Method,"","",Upper_Ma_Price,Lower_Ma_Price,6,y);
      if (x!=y)
      { 
         Buffer1[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Upper_Ma_Period,Lower_Ma_Period,"","",Upper_Ma_Method,Lower_Ma_Method,"","",Upper_Ma_Price,Lower_Ma_Price,0,y);
         Buffer2[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Upper_Ma_Period,Lower_Ma_Period,"","",Upper_Ma_Method,Lower_Ma_Method,"","",Upper_Ma_Price,Lower_Ma_Price,1,y);
         Buffer3[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Upper_Ma_Period,Lower_Ma_Period,"","",Upper_Ma_Method,Lower_Ma_Method,"","",Upper_Ma_Price,Lower_Ma_Price,2,y);
         Buffer4[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Upper_Ma_Period,Lower_Ma_Period,"","",Upper_Ma_Method,Lower_Ma_Method,"","",Upper_Ma_Price,Lower_Ma_Price,3,y);
       }
       manageArrow(pos);  
   }
   manageAlerts();
   return(0);         
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" PA Bars and Channel  ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," PA Bars and Channel "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":"+Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode  ,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDownCode,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

